local Tunnel = module("vrp", "lib/Tunnel")
local Proxy = module("vrp", "lib/Proxy")

vRPsp = {}
vRP = Proxy.getInterface("vRP")
vRPclient = Tunnel.getInterface("vRP","vRP_sponsor")
BMclient = Tunnel.getInterface("vRP_sponsor","vRP_sponsor")
Tunnel.bindInterface("vRP_sponsor",vRPsp)
Proxy.addInterface("vRP_sponsor",vRPsp)

spUtils = {}
spCars = {}
spTags = {}

local function sp_fixCar(player, choice)
	user_id = vRP.getUserId({player})
	if(spUtils[user_id] ~= true)then
		spUtils[user_id] = true
		TriggerClientEvent('murtaza:fix', player)
		vRPclient.notify(player, {"Ti-ai reparat vehiculul!"})
	else
		vRPclient.notify(player, {"Poti folosii aceasta facilitate peste 1 minut!"})
		return
	end
end

local function sp_revive(player, choice)
	user_id = vRP.getUserId({player})
	if(spUtils[user_id] ~= true)then
		spUtils[user_id] = true
		vRPclient.varyHealth(player,{200})
		vRP.varyThirst({user_id, -100})
		vRP.varyHunger({user_id, -100})
		SetTimeout(500, function()
			vRPclient.varyHealth(player,{200})
			vRP.varyThirst({user_id, -100})
			vRP.varyHunger({user_id, -100})
		end)
		vRPclient.notify(player, {"Ti-ai refacut viata!"})
	else
		vRPclient.notify(player, {"Poti folosii aceasta facilitate peste 1 minut!"})
		return
	end
end

local function sp_weapons(player, choice)
	user_id = vRP.getUserId({player})
	if(spUtils[user_id] ~= true)then
		spUtils[user_id] = true
		vRP.giveInventoryItem({user_id,"WEAPON_COMBATPISTOL",100,true})
		vRP.giveInventoryItem({user_id,"WEAPON_ASSAULTSMG",100,true})
		vRP.giveInventoryItem({user_id,"WEAPON_MACHETE",100,true})
		vRP.giveInventoryItem({user_id,"WEAPON_SPECIALCARBINE",100,true})
		vRP.giveInventoryItem({user_id,"WEAPON_PUMPSHOTGUN",100,true})
		vRP.giveInventoryItem({user_id,"WEAPON_MG",100,true})
		vRPclient.notify(player, {"Ai primit pachetul de arme!"})
	else
		vRPclient.notify(player, {"Poti folosii aceasta facilitate peste 1 minut!"})
		return
	end
end

local function sp_spawnCar(player, choice)
	BMclient.spawnSponsorCar(player, {})
end

vRP.registerMenuBuilder({"main", function(add, data)
	local user_id = vRP.getUserId({data.player})
	if user_id ~= nil then
		local choices = {}
		if vRP.isUserSponsor({user_id}) then
			choices["Sponsor Menu"] = {function(player,choice)
				vRP.buildMenu({"๐’ธSponsor Menu๐’ธ", {player = player}, function(menu)
					menu.name = "๐’ธSponsor Menu๐’ธ"
					menu.css={top="75px",header_color="rgba(200,0,0,0.75)"}
					menu.onclose = function(player) vRP.openMainMenu({player}) end -- nest menu

					menu["🔧 Fix Masina 🔧"] = {sp_fixCar,"🔧 > Repara-ti vehiculul"}
					menu["🏥 Refa Viata 🏥"] = {sp_revive,"🏥 > Refati viata"}
					menu["🔫 Pachet Arme 🔫"] = {sp_weapons,"🔫 > Da-ti un pachet de arme"}
					menu["🏎️ Masina Sponsor 🏎️"] = {sp_spawnCar,"🏎️ > Spawneaza masina sponsorului"}
					vRP.openMenu({player,menu})
				end})
			end, "๐’ธ Facilitati sponsor ๐’ธ"}
		end
		add(choices)
	end
end})

Citizen.CreateThread(function()
	while true do
		Citizen.Wait(60000)
		users = vRP.getUsers({})
		for i, v in pairs(users) do
			if vRP.isUserSponsor({user_id}) and (spUtils[i] == true)then
				spUtils[i] = nil
				vRPclient.notify(v, {"Acum iti poti folosii facilitatile de sponsor!"})
			end
		end
	end
end)

AddEventHandler("vRP:playerLeave", function(user_id, source)
	if(spCars[user_id] ~= nil)then
		BMclient.deleteSponsorCar(-1, {spCars[user_id]})
		spCars[user_id] = nil
	end
	if(spTags[user_id] ~= nil)then
		spTags[user_id] = nil
	end
end)